"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Brand = exports.LogoLink = exports.Img = exports.StorybookLogoStyled = void 0;

var _react = _interopRequireDefault(require("react"));

var _theming = require("@storybook/theming");

var _components = require("@storybook/components");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var StorybookLogoStyled = (0, _theming.styled)(_components.StorybookLogo)({
  width: 'auto',
  height: 22,
  display: 'block'
});
exports.StorybookLogoStyled = StorybookLogoStyled;

var Img = _theming.styled.img({
  width: 'auto',
  height: 'auto',
  display: 'block',
  maxWidth: '100%'
});

exports.Img = Img;

var LogoLink = _theming.styled.a({
  display: 'block',
  width: '100%',
  height: '100%',
  color: 'inherit',
  textDecoration: 'none'
});

exports.LogoLink = LogoLink;
var Brand = (0, _theming.withTheme)(function (_ref) {
  var _ref$theme$brand = _ref.theme.brand,
      _ref$theme$brand$titl = _ref$theme$brand.title,
      title = _ref$theme$brand$titl === void 0 ? 'Storybook' : _ref$theme$brand$titl,
      _ref$theme$brand$url = _ref$theme$brand.url,
      url = _ref$theme$brand$url === void 0 ? './' : _ref$theme$brand$url,
      image = _ref$theme$brand.image;
  var targetValue = url === './' ? '' : '_blank';

  if (image === undefined && url === null) {
    return /*#__PURE__*/_react["default"].createElement(StorybookLogoStyled, {
      alt: title
    });
  }

  if (image === undefined && url) {
    return /*#__PURE__*/_react["default"].createElement(LogoLink, {
      title: title,
      href: url,
      target: targetValue
    }, /*#__PURE__*/_react["default"].createElement(StorybookLogoStyled, {
      alt: title
    }));
  }

  if (image === null && url === null) {
    return title;
  }

  if (image === null && url) {
    return /*#__PURE__*/_react["default"].createElement(LogoLink, {
      href: url,
      target: targetValue,
      dangerouslySetInnerHTML: {
        __html: title
      }
    });
  }

  if (image && url === null) {
    return /*#__PURE__*/_react["default"].createElement(Img, {
      src: image,
      alt: title
    });
  }

  if (image && url) {
    return /*#__PURE__*/_react["default"].createElement(LogoLink, {
      title: title,
      href: url,
      target: targetValue
    }, /*#__PURE__*/_react["default"].createElement(Img, {
      src: image,
      alt: title
    }));
  }

  return null;
});
exports.Brand = Brand;