"use strict";

require("core-js/modules/es.object.assign");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.customBrandImage = exports.longText = exports.onlyText = exports.linkAndText = exports.standardNoLink = exports.standard = exports.standardData = exports.menuHighlighted = exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _theming = require("@storybook/theming");

var _addonActions = require("@storybook/addon-actions");

var _Heading = require("./Heading");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var light = _theming.themes.light;
var theme = (0, _theming.ensure)(light);
var _default = {
  component: _Heading.Heading,
  title: 'UI/Sidebar/Heading',
  decorators: [function (storyFn) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        maxWidth: '240px'
      }
    }, storyFn());
  }],
  excludeStories: /.*Data$/,
  parameters: {
    layout: 'fullscreen'
  }
};
exports["default"] = _default;
var menuItems = [{
  title: 'Menu Item 1',
  onClick: (0, _addonActions.action)('onActivateMenuItem'),
  id: '1'
}, {
  title: 'Menu Item 2',
  onClick: (0, _addonActions.action)('onActivateMenuItem'),
  id: '2'
}, {
  title: 'Menu Item 3',
  onClick: (0, _addonActions.action)('onActivateMenuItem'),
  id: '3'
}];

var menuHighlighted = function menuHighlighted() {
  return /*#__PURE__*/_react["default"].createElement(_Heading.Heading, {
    menuHighlighted: true,
    menu: menuItems
  });
};

exports.menuHighlighted = menuHighlighted;
menuHighlighted.displayName = "menuHighlighted";
var standardData = {
  menu: menuItems
};
exports.standardData = standardData;

var standard = function standard() {
  return /*#__PURE__*/_react["default"].createElement(_theming.ThemeProvider, {
    theme: Object.assign(Object.assign({}, theme), {}, {
      brand: {
        title: undefined,
        url: undefined,
        image: undefined
      }
    })
  }, /*#__PURE__*/_react["default"].createElement(_Heading.Heading, {
    menu: menuItems
  }));
};

exports.standard = standard;
standard.displayName = "standard";

var standardNoLink = function standardNoLink() {
  return /*#__PURE__*/_react["default"].createElement(_theming.ThemeProvider, {
    theme: Object.assign(Object.assign({}, theme), {}, {
      brand: {
        title: undefined,
        url: null,
        image: undefined
      }
    })
  }, /*#__PURE__*/_react["default"].createElement(_Heading.Heading, {
    menu: menuItems
  }));
};

exports.standardNoLink = standardNoLink;
standardNoLink.displayName = "standardNoLink";

var linkAndText = function linkAndText() {
  return /*#__PURE__*/_react["default"].createElement(_theming.ThemeProvider, {
    theme: Object.assign(Object.assign({}, theme), {}, {
      brand: {
        title: 'My title',
        url: 'https://example.com',
        image: null
      }
    })
  }, /*#__PURE__*/_react["default"].createElement(_Heading.Heading, {
    menu: menuItems
  }));
};

exports.linkAndText = linkAndText;
linkAndText.displayName = "linkAndText";

var onlyText = function onlyText() {
  return /*#__PURE__*/_react["default"].createElement(_theming.ThemeProvider, {
    theme: Object.assign(Object.assign({}, theme), {}, {
      brand: {
        title: 'My title',
        url: null,
        image: null
      }
    })
  }, /*#__PURE__*/_react["default"].createElement(_Heading.Heading, {
    menu: menuItems
  }));
};

exports.onlyText = onlyText;
onlyText.displayName = "onlyText";

var longText = function longText() {
  return /*#__PURE__*/_react["default"].createElement(_theming.ThemeProvider, {
    theme: Object.assign(Object.assign({}, theme), {}, {
      brand: {
        title: 'My title is way to long to actually fit',
        url: null,
        image: null
      }
    })
  }, /*#__PURE__*/_react["default"].createElement(_Heading.Heading, {
    menu: menuItems
  }));
};

exports.longText = longText;
longText.displayName = "longText";

var customBrandImage = function customBrandImage() {
  return /*#__PURE__*/_react["default"].createElement(_theming.ThemeProvider, {
    theme: Object.assign(Object.assign({}, theme), {}, {
      brand: {
        title: 'My Title',
        url: 'https://example.com',
        image: 'https://via.placeholder.com/150x22'
      }
    })
  }, /*#__PURE__*/_react["default"].createElement(_Heading.Heading, {
    menu: menuItems
  }));
};

exports.customBrandImage = customBrandImage;
customBrandImage.displayName = "customBrandImage";