"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.symbol");

require("core-js/modules/es.symbol.description");

require("core-js/modules/es.symbol.iterator");

require("core-js/modules/es.array.filter");

require("core-js/modules/es.array.find");

require("core-js/modules/es.array.from");

require("core-js/modules/es.array.index-of");

require("core-js/modules/es.array.is-array");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.array.map");

require("core-js/modules/es.array.slice");

require("core-js/modules/es.date.to-string");

require("core-js/modules/es.function.name");

require("core-js/modules/es.object.entries");

require("core-js/modules/es.object.keys");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.object.values");

require("core-js/modules/es.regexp.to-string");

require("core-js/modules/es.string.iterator");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RefIndicator = exports.MessageWrapper = void 0;

var _react = _interopRequireWildcard(require("react"));

var _components = require("@storybook/components");

var _theming = require("@storybook/theming");

var _api = require("@storybook/api");

var _Menu = require("./Menu");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var IndicatorPlacement = _theming.styled.aside(function (_ref) {
  var theme = _ref.theme;
  return {
    height: 14,
    display: 'flex',
    '& > * + *': {
      marginLeft: theme.layoutMargin
    }
  };
}, function (_ref2) {
  var theme = _ref2.theme;
  return {
    color: theme.color.mediumdark
  };
});

var IndicatorIcon = function IndicatorIcon(_ref3) {
  var type = _ref3.type;
  var icon;

  switch (true) {
    case type === 'error':
      {
        icon = 'alert';
        break;
      }

    default:
      {
        icon = 'globe';
      }
  }

  return /*#__PURE__*/_react["default"].createElement(_components.Icons, {
    width: "14",
    height: "14",
    icon: icon
  });
};

IndicatorIcon.displayName = "IndicatorIcon";

var Message = _theming.styled.a(function (_ref4) {
  var theme = _ref4.theme;
  return {
    textDecoration: 'none',
    lineHeight: '18px',
    padding: 10,
    display: 'flex',
    flexDirection: 'row',
    alignItems: 'flex-start',
    color: theme.color.darker,
    '&:hover': {
      background: theme.background.hoverable,
      color: theme.color.darker
    },
    '&:link': {
      color: theme.color.darker
    },
    '&:active': {
      color: theme.color.darker
    },
    '&:focus': {
      color: theme.color.darker
    },
    '& > *': {
      flex: 1
    },
    '& > svg': {
      marginTop: 5,
      width: 20,
      marginRight: 10,
      flex: 'unset'
    }
  };
});

var MessageWrapper = _theming.styled.div({
  width: 280,
  boxSizing: 'border-box',
  borderRadius: 8,
  overflow: 'hidden'
});

exports.MessageWrapper = MessageWrapper;
var BlueIcon = (0, _theming.styled)(_components.Icons)(function (_ref5) {
  var theme = _ref5.theme;
  return {
    color: theme.color.secondary
  };
});
var YellowIcon = (0, _theming.styled)(_components.Icons)(function (_ref6) {
  var theme = _ref6.theme;
  return {
    color: theme.color.gold
  };
});

var Version = _theming.styled.div({
  display: 'flex',
  alignItems: 'center',
  fontSize: 11,
  '& > * + *': {
    marginLeft: 4
  }
});

var CurrentVersion = function CurrentVersion(_ref7) {
  var url = _ref7.url,
      versions = _ref7.versions;
  var currentVersionId = (0, _react.useMemo)(function () {
    var c = Object.entries(versions).find(function (_ref8) {
      var _ref9 = _slicedToArray(_ref8, 2),
          k = _ref9[0],
          v = _ref9[1];

      return v === url;
    });
    return c && c[0] ? c[0] : 'current';
  }, [url, versions]);
  return /*#__PURE__*/_react["default"].createElement(Version, null, /*#__PURE__*/_react["default"].createElement("span", null, currentVersionId), /*#__PURE__*/_react["default"].createElement(_components.Icons, {
    width: "12",
    height: "12",
    icon: "chevrondown"
  }));
};

CurrentVersion.displayName = "CurrentVersion";
var RefIndicator = (0, _react.forwardRef)(function (_ref10, forwardedRef) {
  var state = _ref10.state,
      ref = _objectWithoutProperties(_ref10, ["state"]);

  var api = (0, _api.useStorybookApi)();
  var list = (0, _react.useMemo)(function () {
    return Object.values(ref.stories || {});
  }, [ref.stories]);
  var componentCount = (0, _react.useMemo)(function () {
    return list.filter(function (v) {
      return v.isComponent;
    }).length;
  }, [list]);
  var leafCount = (0, _react.useMemo)(function () {
    return list.filter(function (v) {
      return v.isLeaf;
    }).length;
  }, [list]);
  var changeVersion = (0, _react.useCallback)(function (event, item) {
    event.preventDefault();
    api.changeRefVersion(ref.id, item.href);
  }, []);
  return /*#__PURE__*/_react["default"].createElement(IndicatorPlacement, {
    ref: forwardedRef
  }, /*#__PURE__*/_react["default"].createElement(_components.WithTooltip, {
    placement: "bottom-start",
    trigger: "click",
    tooltip: /*#__PURE__*/_react["default"].createElement(MessageWrapper, null, /*#__PURE__*/_react["default"].createElement(_components.Spaced, {
      row: 0
    }, state === 'loading' && /*#__PURE__*/_react["default"].createElement(LoadingMessage, {
      url: ref.url
    }), state === 'ready' && /*#__PURE__*/_react["default"].createElement(ReadyMessage, {
      url: ref.url,
      componentCount: componentCount,
      leafCount: leafCount
    }), ref.type === 'auto-inject' && state !== 'error' && /*#__PURE__*/_react["default"].createElement(PerformanceDegradedMessage, null), state === 'error' && /*#__PURE__*/_react["default"].createElement(ErrorOccurredMessage, null)))
  }, /*#__PURE__*/_react["default"].createElement(IndicatorIcon, {
    type: state
  })), ref.versions ? /*#__PURE__*/_react["default"].createElement(_components.WithTooltip, {
    placement: "bottom-start",
    trigger: "click",
    tooltip: /*#__PURE__*/_react["default"].createElement(_components.TooltipLinkList, {
      links: Object.entries(ref.versions).map(function (_ref11) {
        var _ref12 = _slicedToArray(_ref11, 2),
            id = _ref12[0],
            href = _ref12[1];

        return {
          left: href === ref.url ? /*#__PURE__*/_react["default"].createElement(_Menu.MenuItemIcon, {
            icon: "check"
          }) : /*#__PURE__*/_react["default"].createElement("span", null),
          id: id,
          title: id,
          href: href,
          onClick: changeVersion
        };
      })
    })
  }, /*#__PURE__*/_react["default"].createElement(CurrentVersion, {
    url: ref.url,
    versions: ref.versions
  })) : null);
});
exports.RefIndicator = RefIndicator;

var PerformanceDegradedMessage = function PerformanceDegradedMessage() {
  return /*#__PURE__*/_react["default"].createElement(Message, {
    href: "https://storybook.js.org",
    target: "_blank"
  }, /*#__PURE__*/_react["default"].createElement(YellowIcon, {
    icon: "lightning"
  }), /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("strong", null, "Reduce lag"), /*#__PURE__*/_react["default"].createElement("div", null, "Learn how to speed up Storybook Composition performance")));
};

PerformanceDegradedMessage.displayName = "PerformanceDegradedMessage";

var ErrorOccurredMessage = function ErrorOccurredMessage() {
  return /*#__PURE__*/_react["default"].createElement(Message, {
    href: "https://storybook.js.org",
    target: "_blank"
  }, /*#__PURE__*/_react["default"].createElement(YellowIcon, {
    icon: "book"
  }), /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("strong", null, "A problem occurred"), /*#__PURE__*/_react["default"].createElement("div", null, "Explore the documentation")));
};

ErrorOccurredMessage.displayName = "ErrorOccurredMessage";

var ReadyMessage = function ReadyMessage(_ref13) {
  var url = _ref13.url,
      componentCount = _ref13.componentCount,
      leafCount = _ref13.leafCount;
  return /*#__PURE__*/_react["default"].createElement(Message, {
    href: url,
    target: "_blank"
  }, /*#__PURE__*/_react["default"].createElement(BlueIcon, {
    icon: "globe"
  }), /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("strong", null, "View external storybook"), /*#__PURE__*/_react["default"].createElement("div", null, "Explore ", componentCount, " components and ", leafCount, " stories in a new browser tab")));
};

ReadyMessage.displayName = "ReadyMessage";

var LoadingMessage = function LoadingMessage(_ref14) {
  var url = _ref14.url;
  return /*#__PURE__*/_react["default"].createElement(Message, {
    href: url,
    target: "_blank"
  }, /*#__PURE__*/_react["default"].createElement(BlueIcon, {
    icon: "time"
  }), /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("strong", null, "Please wait"), /*#__PURE__*/_react["default"].createElement("div", null, "This storybook is being loaded, explore in a new browser tab")));
};

LoadingMessage.displayName = "LoadingMessage";