"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.symbol");

require("core-js/modules/es.symbol.description");

require("core-js/modules/es.symbol.iterator");

require("core-js/modules/es.array.from");

require("core-js/modules/es.array.is-array");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.array.map");

require("core-js/modules/es.array.reduce");

require("core-js/modules/es.array.slice");

require("core-js/modules/es.date.to-string");

require("core-js/modules/es.function.name");

require("core-js/modules/es.object.assign");

require("core-js/modules/es.object.entries");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.regexp.to-string");

require("core-js/modules/es.string.iterator");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _theming = require("@storybook/theming");

var _components = require("@storybook/components");

var _Heading = require("./Heading");

var _Search = require("./Search");

var _utils = require("./Tree/utils");

var _Refs = require("./Refs");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var Container = _theming.styled.nav({
  position: 'absolute',
  zIndex: 1,
  left: 0,
  top: 0,
  bottom: 0,
  right: 0,
  width: '100%',
  height: '100%'
}, function (_ref) {
  var theme = _ref.theme;
  return {
    color: theme.color.darker
  };
});

var CustomScrollArea = (0, _theming.styled)(_components.ScrollArea)({
  '&&&&& .os-scrollbar-handle:before': {
    left: -12
  },
  '&&&&& .os-scrollbar-vertical': {
    right: 5
  },
  padding: 20
});

var Hr = _theming.styled.hr(function (_ref2) {
  var theme = _ref2.theme;
  return {
    border: '0 none',
    height: 0,
    marginBottom: 0,
    borderTop: "1px solid ".concat(theme.color.mediumlight)
  };
});

var useFilterState = function useFilterState(initial) {
  var _useState = (0, _react.useState)(initial),
      _useState2 = _slicedToArray(_useState, 2),
      state = _useState2[0],
      setState = _useState2[1];

  var changeFilter = (0, _react.useCallback)(function (value) {
    setState(value);
  }, []);
  var value = state.length > 1 ? state : '';
  return [value, changeFilter];
};

var useSearchResults = function useSearchResults(refsList, filter) {
  var refsLengths = (0, _react.useMemo)(function () {
    return refsList.map(function (_ref3) {
      var _ref4 = _slicedToArray(_ref3, 2),
          k = _ref4[0],
          i = _ref4[1];

      return (0, _utils.filteredLength)(i.stories || {}, filter);
    }, 0);
  }, [refsList, filter]);
  var refsTotal = (0, _react.useMemo)(function () {
    return refsLengths.reduce(function (acc, i) {
      return acc + i;
    }, 0);
  }, [refsList, filter]);
  return {
    total: refsTotal || 0,
    list: refsLengths
  };
};

var useCombination = function useCombination(stories, ready, error, refs) {
  var merged = (0, _react.useMemo)(function () {
    return Object.assign({
      storybook_internal: {
        stories: stories,
        title: null,
        id: 'storybook_internal',
        url: 'iframe.html',
        ready: ready,
        error: error
      }
    }, refs);
  }, [refs, stories]);
  return (0, _react.useMemo)(function () {
    return Object.entries(merged);
  }, [merged]);
};

var Sidebar = function Sidebar(_ref5) {
  var storyId = _ref5.storyId,
      stories = _ref5.stories,
      storiesConfigured = _ref5.storiesConfigured,
      storiesFailed = _ref5.storiesFailed,
      menu = _ref5.menu,
      _ref5$menuHighlighted = _ref5.menuHighlighted,
      menuHighlighted = _ref5$menuHighlighted === void 0 ? false : _ref5$menuHighlighted,
      _ref5$refs = _ref5.refs,
      refs = _ref5$refs === void 0 ? {} : _ref5$refs;

  var _useFilterState = useFilterState(''),
      _useFilterState2 = _slicedToArray(_useFilterState, 2),
      filter = _useFilterState2[0],
      setFilter = _useFilterState2[1];

  var combined = useCombination(stories, storiesConfigured, storiesFailed, refs);

  var _useSearchResults = useSearchResults(combined, filter),
      total = _useSearchResults.total,
      list = _useSearchResults.list;

  var resultLess = total === 0 && filter;
  return /*#__PURE__*/_react["default"].createElement(Container, {
    className: "container sidebar-container"
  }, /*#__PURE__*/_react["default"].createElement(CustomScrollArea, {
    vertical: true
  }, /*#__PURE__*/_react["default"].createElement(_components.Spaced, {
    row: 2
  }, /*#__PURE__*/_react["default"].createElement(_Heading.Heading, {
    className: "sidebar-header",
    menuHighlighted: menuHighlighted,
    menu: menu
  }), /*#__PURE__*/_react["default"].createElement(_Search.Search, {
    key: "filter",
    onChange: setFilter
  }), resultLess ? /*#__PURE__*/_react["default"].createElement(_components.Placeholder, null, "This filter resulted in 0 results") : null, /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, combined.map(function (_ref6, index) {
    var _ref7 = _slicedToArray(_ref6, 2),
        k = _ref7[0],
        v = _ref7[1];

    var isHidden = !!(filter && !list[index]);
    return /*#__PURE__*/_react["default"].createElement(_react.Fragment, {
      key: k
    }, index === 0 || isHidden ? null : /*#__PURE__*/_react["default"].createElement(Hr, null), /*#__PURE__*/_react["default"].createElement(_Refs.Ref, _extends({}, v, {
      storyId: storyId,
      filter: filter,
      isHidden: isHidden
    })));
  })))));
};

Sidebar.displayName = "Sidebar";
var _default = Sidebar;
exports["default"] = _default;