"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.darkWithRefs = exports.withRefs = exports.isEmpty = exports.isLoading = exports.simple = exports.loadingData = exports.simpleData = exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _theming = require("@storybook/theming");

var _Sidebar = _interopRequireDefault(require("./Sidebar"));

var _Heading = require("./Heading.stories");

var _mockdata = require("./mockdata");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _default = {
  component: _Sidebar["default"],
  title: 'UI/Sidebar/Sidebar',
  excludeStories: /.*Data$/
};
exports["default"] = _default;
var menu = _Heading.standardData.menu;
var stories = _mockdata.mockDataset.withRoot;
var storyId = '1-12-121';
var simpleData = {
  menu: menu,
  stories: stories,
  storyId: storyId
};
exports.simpleData = simpleData;
var loadingData = {
  menu: menu,
  stories: {}
};
exports.loadingData = loadingData;
var refs = {
  optimized: {
    id: 'optimized',
    title: 'It is optimized',
    url: 'https://example.com',
    ready: false,
    type: 'lazy',
    stories: stories
  },
  empty: {
    id: 'empty',
    title: 'It is empty',
    url: 'https://example.com',
    ready: false,
    type: 'lazy',
    stories: {}
  },
  startInjected_unknown: {
    id: 'startInjected_unknown',
    title: 'It started injected and is ready',
    url: 'https://example.com',
    type: 'unknown',
    ready: false,
    stories: stories
  },
  startInjected_loading: {
    id: 'startInjected_loading',
    title: 'It started injected and is loading',
    url: 'https://example.com',
    type: 'auto-inject',
    ready: false,
    stories: stories
  },
  startInjected_ready: {
    id: 'startInjected_ready',
    title: 'It started injected and is ready',
    url: 'https://example.com',
    type: 'auto-inject',
    ready: true,
    stories: stories
  },
  versions: {
    id: 'versions',
    title: 'It has versions',
    url: 'https://example.com',
    type: 'lazy',
    stories: stories,
    versions: {
      '1.0.0': 'https://example.com/v1',
      '2.0.0': 'https://example.com'
    }
  },
  versionsMissingCurrent: {
    id: 'versions_missing_current',
    title: 'It has versions',
    url: 'https://example.com',
    type: 'lazy',
    stories: stories,
    versions: {
      '1.0.0': 'https://example.com/v1',
      '2.0.0': 'https://example.com/v2'
    }
  },
  error: {
    id: 'error',
    title: 'This has problems',
    url: 'https://example.com',
    type: 'lazy',
    stories: {},
    error: function () {
      try {
        throw new Error('There was a severe problem');
      } catch (e) {
        return e;
      }
    }()
  },
  auth: {
    id: 'Authentication',
    title: 'This requires a login',
    url: 'https://example.com',
    type: 'lazy',
    stories: {},
    loginUrl: 'https://example.com'
  },
  "long": {
    id: 'long',
    title: 'This storybook has a very very long name for some reason',
    url: 'https://example.com',
    stories: stories,
    type: 'lazy',
    versions: {
      '111.111.888-new': 'https://example.com/new',
      '111.111.888': 'https://example.com'
    }
  }
};

var simple = function simple() {
  return /*#__PURE__*/_react["default"].createElement(_Sidebar["default"], {
    storiesConfigured: true,
    menu: menu,
    stories: stories,
    storyId: storyId,
    refs: {}
  });
};

exports.simple = simple;
simple.displayName = "simple";

var isLoading = function isLoading() {
  return /*#__PURE__*/_react["default"].createElement(_Sidebar["default"], {
    storiesConfigured: false,
    menu: menu,
    stories: {},
    isLoading: true,
    refs: {}
  });
};

exports.isLoading = isLoading;
isLoading.displayName = "isLoading";

var isEmpty = function isEmpty() {
  return /*#__PURE__*/_react["default"].createElement(_Sidebar["default"], {
    storiesConfigured: true,
    menu: menu,
    stories: {},
    isLoading: true,
    refs: {}
  });
};

exports.isEmpty = isEmpty;
isEmpty.displayName = "isEmpty";

var withRefs = function withRefs() {
  return /*#__PURE__*/_react["default"].createElement(_Sidebar["default"], {
    storiesConfigured: true,
    menu: menu,
    stories: stories,
    isLoading: true,
    refs: refs
  });
};

exports.withRefs = withRefs;
withRefs.displayName = "withRefs";

var darkWithRefs = function darkWithRefs() {
  return /*#__PURE__*/_react["default"].createElement(_theming.ThemeProvider, {
    theme: (0, _theming.ensure)(_theming.themes.dark)
  }, /*#__PURE__*/_react["default"].createElement(_Sidebar["default"], {
    storiesConfigured: true,
    menu: menu,
    stories: stories,
    isLoading: true,
    refs: refs
  }));
};

exports.darkWithRefs = darkWithRefs;
darkWithRefs.displayName = "darkWithRefs";
darkWithRefs.parameters = {
  backgrounds: {
    "default": 'dark',
    values: [{
      name: 'dark',
      value: '#222222',
      "default": true
    }]
  }
};