"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es.symbol");

require("core-js/modules/es.symbol.description");

require("core-js/modules/es.symbol.iterator");

require("core-js/modules/es.array.concat");

require("core-js/modules/es.array.filter");

require("core-js/modules/es.array.from");

require("core-js/modules/es.array.is-array");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.array.reduce");

require("core-js/modules/es.array.slice");

require("core-js/modules/es.date.to-string");

require("core-js/modules/es.function.name");

require("core-js/modules/es.object.assign");

require("core-js/modules/es.object.define-property");

require("core-js/modules/es.object.keys");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.object.values");

require("core-js/modules/es.regexp.to-string");

require("core-js/modules/es.string.iterator");

require("core-js/modules/web.dom-collections.iterator");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useDataset = exports.ExpanderContext = void 0;

var _react = _interopRequireWildcard(require("react"));

var _api = require("@storybook/api");

var _utils = require("./utils");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var ExpanderContext = _react["default"].createContext({
  setExpanded: function setExpanded() {},
  expandedSet: {}
});

exports.ExpanderContext = ExpanderContext;

var useExpanded = function useExpanded(type, parents, initialFiltered, initialUnfiltered) {
  var expandedSets = {
    filtered: (0, _react.useState)(initialFiltered),
    unfiltered: (0, _react.useState)(initialUnfiltered)
  };

  var _expandedSets$type = _slicedToArray(expandedSets[type], 2),
      state = _expandedSets$type[0],
      setState = _expandedSets$type[1];

  (0, _react.useEffect)(function () {
    expandedSets.filtered[1](initialFiltered);
    expandedSets.unfiltered[1](initialUnfiltered);
  }, [initialFiltered, initialUnfiltered]);
  var set = (0, _react.useMemo)(function () {
    return Object.assign(Object.assign({}, state), parents.reduce(function (acc, item) {
      return Object.assign(Object.assign({}, acc), {}, _defineProperty({}, item.id, true));
    }, {}));
  }, [state, parents]);
  return {
    expandedSet: set,
    setExpanded: setState
  };
};

var useSelected = function useSelected(dataset, storyId) {
  return (0, _react.useMemo)(function () {
    return Object.keys(dataset).reduce(function (acc, k) {
      return Object.assign(acc, _defineProperty({}, k, k === storyId));
    }, {});
  }, [dataset, storyId]);
};

var useFiltered = function useFiltered(dataset, filter, parents, storyId) {
  var extra = (0, _react.useMemo)(function () {
    if (dataset[storyId]) {
      return parents.reduce(function (acc, item) {
        return Object.assign(Object.assign({}, acc), {}, _defineProperty({}, item.id, item));
      }, dataset[storyId] ? _defineProperty({}, storyId, dataset[storyId]) : {});
    }

    return {};
  }, [parents]);
  var filteredSet = (0, _react.useMemo)(function () {
    return filter ? (0, _utils.toFiltered)(dataset, filter) : dataset;
  }, [dataset, filter]);
  return (0, _react.useMemo)(function () {
    return filteredSet[storyId] ? filteredSet : Object.assign(Object.assign({}, extra), filteredSet);
  }, [extra, filteredSet]);
};

var useDataset = function useDataset() {
  var dataset = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var filter = arguments.length > 1 ? arguments[1] : undefined;
  var storyId = arguments.length > 2 ? arguments[2] : undefined;
  var emptyInitial = (0, _react.useMemo)(function () {
    return {
      filtered: {},
      unfiltered: {}
    };
  }, []);
  var datasetKeys = Object.keys(dataset);
  var initial = (0, _react.useMemo)(function () {
    if (datasetKeys.length) {
      return Object.keys(dataset).reduce(function (acc, k) {
        return {
          filtered: Object.assign(Object.assign({}, acc.filtered), {}, _defineProperty({}, k, true)),
          unfiltered: Object.assign(Object.assign({}, acc.unfiltered), {}, _defineProperty({}, k, false))
        };
      }, {
        filtered: {},
        unfiltered: {}
      });
    }

    return emptyInitial;
  }, [dataset]);
  var type = filter.length >= 2 ? 'filtered' : 'unfiltered';
  var parents = (0, _react.useMemo)(function () {
    return (0, _utils.getParents)(storyId, dataset);
  }, [dataset[storyId]]);

  var _useExpanded = useExpanded(type, parents, initial.filtered, initial.unfiltered),
      expandedSet = _useExpanded.expandedSet,
      setExpanded = _useExpanded.setExpanded;

  var selectedSet = useSelected(dataset, storyId);
  var filteredSet = useFiltered(dataset, filter, parents, storyId);
  var length = (0, _react.useMemo)(function () {
    return Object.keys(filteredSet).length;
  }, [filteredSet]);
  var topLevel = (0, _react.useMemo)(function () {
    return Object.values(filteredSet).filter(function (i) {
      return i.depth === 0 && !(0, _api.isRoot)(i) || !(0, _api.isRoot)(i) && (0, _api.isRoot)(filteredSet[i.parent]);
    });
  }, [filteredSet]);
  (0, _react.useEffect)(function () {
    if (type === 'filtered') {
      if (topLevel.length < 18) {
        setExpanded(initial.filtered);
      } else {
        setExpanded(initial.unfiltered);
      }
    }
  }, [filter]);

  var _useMemo = (0, _react.useMemo)(function () {
    return (0, _utils.getMains)(filteredSet).reduce(function (acc, item) {
      return (0, _api.isRoot)(item) ? Object.assign(Object.assign({}, acc), {}, {
        roots: [].concat(_toConsumableArray(acc.roots), [item])
      }) : Object.assign(Object.assign({}, acc), {}, {
        others: [].concat(_toConsumableArray(acc.others), [item])
      });
    }, {
      roots: [],
      others: []
    });
  }, [filteredSet]),
      roots = _useMemo.roots,
      others = _useMemo.others;

  return {
    roots: roots,
    others: others,
    length: length,
    dataSet: filteredSet,
    selectedSet: selectedSet,
    expandedSet: expandedSet,
    setExpanded: setExpanded
  };
};

exports.useDataset = useDataset;